/*
                StartAndEndPoint l1 = parseArray[i];
                StartAndEndPoint l2 = parseArray[i+ 1];
                //CHECK WHICH line starts after the other
                //If l1 is starting after, then comparisons are based around l1.s
                //System.out.println("l1: " + l1.getP1().x);
                //System.out.println("l2: " + l2.getP1().x);

                System.out.println("1.0: L1S: " + l1.getP1().x + " larger than L2S: " + l2.getP1().x);
                if(l1.getP1().x > l2.getP1().x) {
                    System.out.println("1.1: Comparing L1S: " + l1.getP1().x + " less than L2E: " + l2.getP2().x);
                    if (l1.getP1().x < l2.getP2().x) {
                        //AND
                        System.out.println("1.2: Comparing L1S: " + l1.getP1().x + " larger than L2S: " + l2.getP1().x);
                        if (l1.getP1().x > l2.getP1().x) {
                            System.out.println("1: Success. NEXT");
                            //IT IS INTERSECTED
                            continue;
                        }
                        else {
                            //FAILED SECOND COMPARISON
                            System.out.println("1: Fail");
                        }
                    }
                    else {
                        System.out.println("Checking other line");
                    }
                    System.out.println("2.0: L2S: " + l2.getP1().x + " larger than  L1S: " + l1.getP1().x);
                }
                //If l2 is starting after, then comparisons are based around l2.s
                else if(l2.getP1().x > l1.getP1().x) {
                    System.out.println("2.1: Comparing L2S: " + l1.getP1().x + " less than L1E: " + l2.getP2().x);
                    if (l2.getP1().x < l1.getP2().x) {
                        //AND
                        System.out.println("2.2: Comparing L2S: " + l2.getP1().x + " larger than L1S: " + l1.getP1().x);
                        if (l2.getP1().x > l1.getP1().x) {
                            System.out.println("2: Success");
                            //IT IS INTERSECTED
                            //continue;
                        }
                        else {
                            //FAILED SECOND COMPARISON
                            System.out.println("2: Fail");
                            //return false;
                        }
                    }
                    else {
                        System.out.println("Failed second comparison RETURN FALSE");
                        return false;
                    }
                    //return false;
                }
                else{
                    System.out.println("NEITHER RETURN FALSE");
                    return false;
                }
  */

import org.opencv.core.*;
import org.opencv.core.Point;
import org.opencv.highgui.HighGui;
import org.opencv.imgcodecs.Imgcodecs;
import org.opencv.imgproc.Imgproc;
import org.opencv.photo.Photo;
import static org.opencv.imgcodecs.Imgcodecs.imwrite;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.File;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import javax.imageio.ImageIO;

//REFERENCES:
//https://docs.opencv.org/3.4.3/d9/db0/tutorial_hough_lines.
//https://stackoverflow.com/questions/43443309/count-red-pixel-in-a-given-image
//https://www.wikihow.com/Calculate-Percentage-in-Java
//https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
//https://beginnersbook.com/2013/12/java-arraylist-of-object-sort-example-comparable-and-comparator/
//https://www.programiz.com/java-programming/examples/standard-deviation
//https://www.geeksforgeeks.org/how-to-remove-duplicates-from-arraylist-in-java/
//https://stackoverflow.com/questions/7988486/how-do-you-calculate-the-variance-median-and-standard-deviation-in-c-or-java/7988556
//https://stackoverflow.com/questions/10396970/sort-a-list-that-contains-a-custom-class
//https://stackoverflow.com/questions/37946482/crop-images-area-with-opencv-java
//https://docs.opencv.org/3.4/dd/dd7/tutorial_morph_lines_detection.html



//GOAL for 21st


//Classifier 01
//Have args so can call "java image-identification-classifier01 XX XX"
//args can be parameters in algorthim such as threshold or theta?
//Run on 5000 images.
//Record success rates
//All done with makefile


//But first understand houghline transform
//Know what the algorithm being used is doing.
//MAke constants for this classifier
//Make java be able to run on CMD line

public class MainMorph {
    //GLOBAL_CONSTANTS

    static double THRESHOLD_C = 4;


    //
    static class StartAndEndPoint {
        //PRIVATES
        private Point _p1;
        private Point _p2;
        //CONSTRUCTOR
        public StartAndEndPoint(Point p1, Point p2){
            _p1 = p1;
            _p2 = p2;
        }
        //GETTERS
        public Point getP1(){
            return _p1;
        }
        public Point getP2(){
            return  _p2;
        }
        //SETTERS
        public void setP1(Point p1){
            _p1 = p1;
        }
        public void setP2(Point p2){
            _p2 = p2;
        }

        //ToString
        public  String toString(){
            return "Start: " + _p1 + " End: " + _p2;
        }

    }
    private static  BufferedImage toBufferedImage(Mat mat){
        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
        try{
            int type = BufferedImage.TYPE_3BYTE_BGR;
            int bufferSize = mat.channels() * mat.cols() * mat.rows();
            byte[] b = new byte[bufferSize];
            //get all the pixels
            mat.get(0, 0, b);
            BufferedImage image = new BufferedImage(mat.cols(), mat.rows(), type);
            final byte[] targetPixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
            System.arraycopy(b, 0, targetPixels, 0, b.length);
            return image;
        }
        catch(Exception e){
            System.err.println(e);
        }
        return null;
    }

    private static void showWaitDestroy(String winname, Mat img) {
        HighGui.imshow(winname, img);
        HighGui.moveWindow(winname, 500, 0);
        HighGui.waitKey(0);
        HighGui.destroyWindow(winname);
    }
    //MAIN
    public static void main(String[] args) {

        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);

        try {
            ArrayList<StartAndEndPoint> pointArrayList = new ArrayList<>();

            //Variables
            int codeVersion = 2;
            Mat edgesDetected = new Mat();
            Mat mid = new Mat();
            Mat edgesDetectedRGB = new Mat();
            Mat clustersFoundRGB = new Mat();
            String directory = "/Scratch/cpb16/is-sheet-music-encore/download-images/MU/";
            String hiresDirectory = "/Scratch/cpb16/is-sheet-music-encore/hires-download-images/";

            //!!!!!!!!!!!!!!!!!!!!!!!!!!!NOT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            //mdp.39015097852365-2.png 176 lines    Contents page.
            //mdp.39015097852555-3.png 76  lines
            //!!!!!!!!!!!!!!!!!!!!!!!!!!!NOTNOT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            //coo.31924062612282-9.png 8   lines
            //String default_file = directory+"NotSheetMusic/coo.31924062612282-9.png";
            //String default_file = directory+"NotSheetMusic/mdp.39015097852365-2.png";
            //String default_file ="TestImages/NotNot/mdp.39015080972303-3.png";
            //String default_file =hiresDirectory+"BK/NotSheetMusic/aeu.ark+=13960=t2q53nq6w-6.png";
              String default_file = "/Scratch/cpb16/is-sheet-music-encore/image-identification-terminal/TestImages/test-coo.31924062612282-9.png";
            //String default_file =hiresDirectory+"BK/NotSheetMusic/aeu.ark+=13960=t9z03w65z-4.png";

            //System.out.println(default_file);
            //String default_file = "TestImages/NotSheetMusic01.png";
            //String default_file = "TestImages/NotSheetMusic02.png";
            //String default_file = "TestImages/SheetMusic01.png";
            //String default_file = "TestImages/SheetMusic02.png";
            //String default_file = "TestImages/vLine.png";
            String filename = ((args.length > 0) ? args[0] : default_file);
            File file = new File(filename);
            if(!file.exists()){System.err.println("Image not found: "+ filename);}

            int horizontalLineCount =0;

            // Load an image
            Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
            // Edge detection
            
            Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
            //TEST PARAMETERSImgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 531,1);



            //****************MORPHOLOGY****************************************************************************************
            //ADDIOTIONAL FILTERING TO STOP STREAKS
            //LOOK INTO STREAKS MORPHOGOLY.
            //****************MORPHOLOGY****************************************************************************************

            // Create the images that will use to extract the horizontal and vertical lines

            //dynamic morphology??
            if(codeVersion == 1) {
                int hori = original.width();
                int vert = original.height();
                //Find ratio between 100 and width and 100 and height
                int divX = hori/10;
                int divY = vert/10;
                int sizeX = (hori/divX) * 10;
                int sizeY = (vert/divY) * 10;

                Mat test = original.clone();
                showWaitDestroy("Original", test);

                System.out.println("hori: " + hori + '\t' + "vert: " + vert);
                System.out.println("sizeX: " + sizeX + '\t' + "sizeY: " + sizeY);

                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX, (sizeY/100)));
                Imgproc.erode(test,test,kernelErode);
                showWaitDestroy("01 Erode", test);

                Mat kernelDialate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX,(sizeY/10)));
                Imgproc.dilate(test, test, kernelDialate);
                showWaitDestroy("02 Dialate", test);

                Mat kernelErodeAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10),(sizeY/5)));
                Imgproc.erode(test,test,kernelErodeAgain);
                showWaitDestroy(" 03 Erode Again", test);

                Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10)*3,(sizeY/10)*3));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelClose);
                showWaitDestroy("04 Close", test);

                Imgproc.adaptiveThreshold(test, test,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
                showWaitDestroy("05 Binarized", test);

                Mat kernelOpen = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10),(sizeY/20)));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_OPEN, kernelOpen);
                showWaitDestroy(" 06 Open", test);

                Mat kernelDialateAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/5),(sizeY/100)));
                Imgproc.dilate(test, test, kernelDialateAgain);
                showWaitDestroy("07 Dialate", test);


                Mat kernelCloseAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10),(sizeY/2)));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelCloseAgain);
                showWaitDestroy(" 08 Close Again (Final)", test);
            }
            //Successful hardcode for morhpology
            if (codeVersion == 2) {
                Mat test = original.clone();
                showWaitDestroy("00 Original", test);

                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,1));
                Imgproc.erode(test,test,kernelErode);
                showWaitDestroy("01 Erode", test);

                Mat kernelDialate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,10));
                Imgproc.dilate(test, test, kernelDialate);
                showWaitDestroy("02 Dialate", test);

                Mat kernelErodeAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,20));
                Imgproc.erode(test,test,kernelErodeAgain);
                showWaitDestroy(" 03 Erode Again", test);

                Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(50,30));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelClose);
                showWaitDestroy("04 Close", test);

                Imgproc.adaptiveThreshold(test, test,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
                showWaitDestroy("05 Binarized", test);

                Mat kernelOpen = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,4));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_OPEN, kernelOpen);
                showWaitDestroy(" 06 Open", test);

//                Mat kernelDialateAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(1,10));
//                Imgproc.dilate(test, test, kernelDialateAgain);
//                showWaitDestroy("07 Dialate", test);

                //FIGURE OUT FLOOD FILL!!
                Imgproc.floodFill(test,test, new Point(1,1), new Scalar(2));


                Mat kernelCloseAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,50));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelCloseAgain);
                showWaitDestroy(" 08 Close Again (Final)", test);

            }
            //Tutorial/Demo Code
            if (codeVersion == 3) {
                Mat horizontal = original.clone();
                Mat vertical = original.clone();
                // Specify size on horizontal axis
                int horizontal_size = horizontal.cols() / 50;
                // Create structure element for extracting horizontal lines through morphology operations
                Mat horizontalStructure = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(horizontal_size, 2));
                // Apply morphology operations
                Imgproc.erode(horizontal, horizontal, horizontalStructure);
                Imgproc.dilate(horizontal, horizontal, horizontalStructure);
                // Show extracted horizontal lines
                showWaitDestroy("horizontal", horizontal);
                // Specify size on vertical axis
                int vertical_size = vertical.rows() / 30;
                // Create structure element for extracting vertical lines through morphology operations
                Mat verticalStructure = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(1, vertical_size));
                // Apply morphology operations
                Imgproc.erode(vertical, vertical, verticalStructure);
                Imgproc.dilate(vertical, vertical, verticalStructure);
                // Show extracted vertical lines
                showWaitDestroy("vertical", vertical);
                // Inverse vertical image
                Core.bitwise_not(vertical, vertical);
                showWaitDestroy("vertical_bit", vertical);
                // Extract edges and smooth image according to the logic
                // 1. extract edges
                // 2. dilate(edges)
                // 3. src.copyTo(smooth)
                // 4. blur smooth img
                // 5. smooth.copyTo(src, edges)
                // Step 1
                Mat edges = new Mat();
                Imgproc.adaptiveThreshold(vertical, edges, 255, Imgproc.ADAPTIVE_THRESH_MEAN_C, Imgproc.THRESH_BINARY, 3, -2);
                showWaitDestroy("edges", edges);
                // Step 2
                Mat kernel = Mat.ones(2, 2, CvType.CV_8UC1);
                Imgproc.dilate(edges, edges, kernel);
                showWaitDestroy("dilate", edges);
                // Step 3
                Mat smooth = new Mat();
                vertical.copyTo(smooth);
                // Step 4
                Imgproc.blur(smooth, smooth, new Size(2, 2));
                // Step 5
                smooth.copyTo(vertical, edges);
                // Show final result
                showWaitDestroy("smooth - final", vertical);
                System.exit(0);
            }




            //****************MORPHOLOGY****************************************************************************************

            BufferedImage toBeClassifiedImg = toBufferedImage(edgesDetectedRGB);


            //Display Results
            //HighGui.imshow("Source", original);
            //HighGui.imshow("Just Edges", justEdges); //TESTING


            HighGui.imshow("LINESFOUND", edgesDetectedRGB);
            HighGui.resizeWindow("LINESFOUND", 1000,1000);
            
            //HighGui.imshow("CLUSTERS FOUND", clustersFoundRGB);
            //HighGui.imshow("Detected Lines (in red) - negative", edgesDetectedRGBProb);

            //COUNT OF LINES CLASSIFICATION
            //System.out.println("LINE CLUSTER RESULT: " +  ClassifierLineClusterOLD(toBeClassifiedImg).get(0) + '\t' + "LinesFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(1) + '\t' + "ClustersFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(2));
            //System.out.println("NEW CLUSTER RESULTS: " +  ClassifierLineClusterPt(pointArrayList,clustersFoundRGB).get(0) + '\t' + "LinesFound: " + horizontalLineCount + '\t' + "ClustersFound: " + ClassifierLineClusterPt(pointArrayList,clustersFoundRGB).get(1));
            //System.out.println(ClassifierLineClusterPt(pointArrayList, clustersFoundRGB));

            //System.out.println("TEST: " + LineCountOrCluster(horizontalLineCount, pointArrayList, clustersFoundRGB));

            // Wait and Exit
            HighGui.waitKey();
            System.exit(0);
        }
        catch(Exception e){
            System.err.println(e);
        }
    }
}
